Code

Catch invalid --depth option passed to clone or fetch
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors      strip everything before a scissors line
21 whitespace=     pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory=      pass it through git-apply
25 C=              pass it through git-apply
26 p=              pass it through git-apply
27 patch-format=   format the patch(es) are in
28 reject          pass it through git-apply
29 resolvemsg=     override error message when patch failure occurs
30 continue        continue applying patches after resolving a conflict
31 r,resolved      synonyms for --continue
32 skip            skip the current patch
33 abort           restore the original branch and abort the patching operation.
34 committer-date-is-author-date    lie about committer date
35 ignore-date     use current timestamp for author date
36 rerere-autoupdate update the index with reused conflict resolution if possible
37 rebasing*       (internal use for git-rebase)"
39 . git-sh-setup
40 prefix=$(git rev-parse --show-prefix)
41 set_reflog_action am
42 require_work_tree
43 cd_to_toplevel
45 git var GIT_COMMITTER_IDENT >/dev/null ||
46         die "You need to set your committer info first"
48 if git rev-parse --verify -q HEAD >/dev/null
49 then
50         HAS_HEAD=yes
51 else
52         HAS_HEAD=
53 fi
55 cmdline="git am"
56 if test '' != "$interactive"
57 then
58         cmdline="$cmdline -i"
59 fi
60 if test '' != "$threeway"
61 then
62         cmdline="$cmdline -3"
63 fi
65 sq () {
66         git rev-parse --sq-quote "$@"
67 }
69 stop_here () {
70     echo "$1" >"$dotest/next"
71     git rev-parse --verify -q HEAD >"$dotest/abort-safety"
72     exit 1
73 }
75 safe_to_abort () {
76         if test -f "$dotest/dirtyindex"
77         then
78                 return 1
79         fi
81         if ! test -s "$dotest/abort-safety"
82         then
83                 return 0
84         fi
86         abort_safety=$(cat "$dotest/abort-safety")
87         if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
88         then
89                 return 0
90         fi
91         echo >&2 "You seem to have moved HEAD since the last 'am' failure."
92         echo >&2 "Not rewinding to ORIG_HEAD"
93         return 1
94 }
96 stop_here_user_resolve () {
97     if [ -n "$resolvemsg" ]; then
98             printf '%s\n' "$resolvemsg"
99             stop_here $1
100     fi
101     echo "When you have resolved this problem run \"$cmdline --resolved\"."
102     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
103     echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
105     stop_here $1
108 go_next () {
109         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
110                 "$dotest/patch" "$dotest/info"
111         echo "$next" >"$dotest/next"
112         this=$next
115 cannot_fallback () {
116         echo "$1"
117         echo "Cannot fall back to three-way merge."
118         exit 1
121 fall_back_3way () {
122     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
124     rm -fr "$dotest"/patch-merge-*
125     mkdir "$dotest/patch-merge-tmp-dir"
127     # First see if the patch records the index info that we can use.
128     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
129         "$dotest/patch" &&
130     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
131     git write-tree >"$dotest/patch-merge-base+" ||
132     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
134     say Using index info to reconstruct a base tree...
135     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136         git apply --cached <"$dotest/patch"
137     then
138         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
139         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
140     else
141         cannot_fallback "Did you hand edit your patch?
142 It does not apply to blobs recorded in its index."
143     fi
145     test -f "$dotest/patch-merge-index" &&
146     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
147     orig_tree=$(cat "$dotest/patch-merge-base") &&
148     rm -fr "$dotest"/patch-merge-* || exit 1
150     say Falling back to patching base and 3-way merge...
152     # This is not so wrong.  Depending on which base we picked,
153     # orig_tree may be wildly different from ours, but his_tree
154     # has the same set of wildly different changes in parts the
155     # patch did not touch, so recursive ends up canceling them,
156     # saying that we reverted all those changes.
158     eval GITHEAD_$his_tree='"$FIRSTLINE"'
159     export GITHEAD_$his_tree
160     if test -n "$GIT_QUIET"
161     then
162             GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
163     fi
164     git-merge-recursive $orig_tree -- HEAD $his_tree || {
165             git rerere $allow_rerere_autoupdate
166             echo Failed to merge in the changes.
167             exit 1
168     }
169     unset GITHEAD_$his_tree
172 clean_abort () {
173         test $# = 0 || echo >&2 "$@"
174         rm -fr "$dotest"
175         exit 1
178 patch_format=
180 check_patch_format () {
181         # early return if patch_format was set from the command line
182         if test -n "$patch_format"
183         then
184                 return 0
185         fi
187         # we default to mbox format if input is from stdin and for
188         # directories
189         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
190         then
191                 patch_format=mbox
192                 return 0
193         fi
195         # otherwise, check the first few lines of the first patch to try
196         # to detect its format
197         {
198                 read l1
199                 read l2
200                 read l3
201                 case "$l1" in
202                 "From "* | "From: "*)
203                         patch_format=mbox
204                         ;;
205                 '# This series applies on GIT commit'*)
206                         patch_format=stgit-series
207                         ;;
208                 "# HG changeset patch")
209                         patch_format=hg
210                         ;;
211                 *)
212                         # if the second line is empty and the third is
213                         # a From, Author or Date entry, this is very
214                         # likely an StGIT patch
215                         case "$l2,$l3" in
216                         ,"From: "* | ,"Author: "* | ,"Date: "*)
217                                 patch_format=stgit
218                                 ;;
219                         *)
220                                 ;;
221                         esac
222                         ;;
223                 esac
224                 if test -z "$patch_format" &&
225                         test -n "$l1" &&
226                         test -n "$l2" &&
227                         test -n "$l3"
228                 then
229                         # This begins with three non-empty lines.  Is this a
230                         # piece of e-mail a-la RFC2822?  Grab all the headers,
231                         # discarding the indented remainder of folded lines,
232                         # and see if it looks like that they all begin with the
233                         # header field names...
234                         tr -d '\015' <"$1" |
235                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
236                         sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
237                         patch_format=mbox
238                 fi
239         } < "$1" || clean_abort
242 split_patches () {
243         case "$patch_format" in
244         mbox)
245                 if test -n "$rebasing" || test t = "$keepcr"
246                 then
247                     keep_cr=--keep-cr
248                 else
249                     keep_cr=
250                 fi
251                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
252                 clean_abort
253                 ;;
254         stgit-series)
255                 if test $# -ne 1
256                 then
257                         clean_abort "Only one StGIT patch series can be applied at once"
258                 fi
259                 series_dir=`dirname "$1"`
260                 series_file="$1"
261                 shift
262                 {
263                         set x
264                         while read filename
265                         do
266                                 set "$@" "$series_dir/$filename"
267                         done
268                         # remove the safety x
269                         shift
270                         # remove the arg coming from the first-line comment
271                         shift
272                 } < "$series_file" || clean_abort
273                 # set the patch format appropriately
274                 patch_format=stgit
275                 # now handle the actual StGIT patches
276                 split_patches "$@"
277                 ;;
278         stgit)
279                 this=0
280                 for stgit in "$@"
281                 do
282                         this=`expr "$this" + 1`
283                         msgnum=`printf "%0${prec}d" $this`
284                         # Perl version of StGIT parse_patch. The first nonemptyline
285                         # not starting with Author, From or Date is the
286                         # subject, and the body starts with the next nonempty
287                         # line not starting with Author, From or Date
288                         perl -ne 'BEGIN { $subject = 0 }
289                                 if ($subject > 1) { print ; }
290                                 elsif (/^\s+$/) { next ; }
291                                 elsif (/^Author:/) { print s/Author/From/ ; }
292                                 elsif (/^(From|Date)/) { print ; }
293                                 elsif ($subject) {
294                                         $subject = 2 ;
295                                         print "\n" ;
296                                         print ;
297                                 } else {
298                                         print "Subject: ", $_ ;
299                                         $subject = 1;
300                                 }
301                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
302                 done
303                 echo "$this" > "$dotest/last"
304                 this=
305                 msgnum=
306                 ;;
307         *)
308                 if test -n "$patch_format"
309                 then
310                         clean_abort "Patch format $patch_format is not supported."
311                 else
312                         clean_abort "Patch format detection failed."
313                 fi
314                 ;;
315         esac
318 prec=4
319 dotest="$GIT_DIR/rebase-apply"
320 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
321 resolvemsg= resume= scissors= no_inbody_headers=
322 git_apply_opt=
323 committer_date_is_author_date=
324 ignore_date=
325 allow_rerere_autoupdate=
327 if test "$(git config --bool --get am.keepcr)" = true
328 then
329     keepcr=t
330 fi
332 while test $# != 0
333 do
334         case "$1" in
335         -i|--interactive)
336                 interactive=t ;;
337         -b|--binary)
338                 : ;;
339         -3|--3way)
340                 threeway=t ;;
341         -s|--signoff)
342                 sign=t ;;
343         -u|--utf8)
344                 utf8=t ;; # this is now default
345         --no-utf8)
346                 utf8= ;;
347         -k|--keep)
348                 keep=t ;;
349         -c|--scissors)
350                 scissors=t ;;
351         --no-scissors)
352                 scissors=f ;;
353         -r|--resolved|--continue)
354                 resolved=t ;;
355         --skip)
356                 skip=t ;;
357         --abort)
358                 abort=t ;;
359         --rebasing)
360                 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
361         -d|--dotest)
362                 die "-d option is no longer supported.  Do not use."
363                 ;;
364         --resolvemsg)
365                 shift; resolvemsg=$1 ;;
366         --whitespace|--directory)
367                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
368         -C|-p)
369                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
370         --patch-format)
371                 shift ; patch_format="$1" ;;
372         --reject|--ignore-whitespace|--ignore-space-change)
373                 git_apply_opt="$git_apply_opt $1" ;;
374         --committer-date-is-author-date)
375                 committer_date_is_author_date=t ;;
376         --ignore-date)
377                 ignore_date=t ;;
378         --rerere-autoupdate|--no-rerere-autoupdate)
379                 allow_rerere_autoupdate="$1" ;;
380         -q|--quiet)
381                 GIT_QUIET=t ;;
382         --keep-cr)
383                 keepcr=t ;;
384         --no-keep-cr)
385                 keepcr=f ;;
386         --)
387                 shift; break ;;
388         *)
389                 usage ;;
390         esac
391         shift
392 done
394 # If the dotest directory exists, but we have finished applying all the
395 # patches in them, clear it out.
396 if test -d "$dotest" &&
397    last=$(cat "$dotest/last") &&
398    next=$(cat "$dotest/next") &&
399    test $# != 0 &&
400    test "$next" -gt "$last"
401 then
402    rm -fr "$dotest"
403 fi
405 if test -d "$dotest"
406 then
407         case "$#,$skip$resolved$abort" in
408         0,*t*)
409                 # Explicit resume command and we do not have file, so
410                 # we are happy.
411                 : ;;
412         0,)
413                 # No file input but without resume parameters; catch
414                 # user error to feed us a patch from standard input
415                 # when there is already $dotest.  This is somewhat
416                 # unreliable -- stdin could be /dev/null for example
417                 # and the caller did not intend to feed us a patch but
418                 # wanted to continue unattended.
419                 test -t 0
420                 ;;
421         *)
422                 false
423                 ;;
424         esac ||
425         die "previous rebase directory $dotest still exists but mbox given."
426         resume=yes
428         case "$skip,$abort" in
429         t,t)
430                 die "Please make up your mind. --skip or --abort?"
431                 ;;
432         t,)
433                 git rerere clear
434                 git read-tree --reset -u HEAD HEAD
435                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
436                 git reset HEAD
437                 git update-ref ORIG_HEAD $orig_head
438                 ;;
439         ,t)
440                 if test -f "$dotest/rebasing"
441                 then
442                         exec git rebase --abort
443                 fi
444                 git rerere clear
445                 if safe_to_abort
446                 then
447                         git read-tree --reset -u HEAD ORIG_HEAD
448                         git reset ORIG_HEAD
449                 fi
450                 rm -fr "$dotest"
451                 exit ;;
452         esac
453         rm -f "$dotest/dirtyindex"
454 else
455         # Make sure we are not given --skip, --resolved, nor --abort
456         test "$skip$resolved$abort" = "" ||
457                 die "Resolve operation not in progress, we are not resuming."
459         # Start afresh.
460         mkdir -p "$dotest" || exit
462         if test -n "$prefix" && test $# != 0
463         then
464                 first=t
465                 for arg
466                 do
467                         test -n "$first" && {
468                                 set x
469                                 first=
470                         }
471                         if is_absolute_path "$arg"
472                         then
473                                 set "$@" "$arg"
474                         else
475                                 set "$@" "$prefix$arg"
476                         fi
477                 done
478                 shift
479         fi
481         check_patch_format "$@"
483         split_patches "$@"
485         # -i can and must be given when resuming; everything
486         # else is kept
487         echo " $git_apply_opt" >"$dotest/apply-opt"
488         echo "$threeway" >"$dotest/threeway"
489         echo "$sign" >"$dotest/sign"
490         echo "$utf8" >"$dotest/utf8"
491         echo "$keep" >"$dotest/keep"
492         echo "$keepcr" >"$dotest/keepcr"
493         echo "$scissors" >"$dotest/scissors"
494         echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
495         echo "$GIT_QUIET" >"$dotest/quiet"
496         echo 1 >"$dotest/next"
497         if test -n "$rebasing"
498         then
499                 : >"$dotest/rebasing"
500         else
501                 : >"$dotest/applying"
502                 if test -n "$HAS_HEAD"
503                 then
504                         git update-ref ORIG_HEAD HEAD
505                 else
506                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
507                 fi
508         fi
509 fi
511 git update-index -q --refresh
513 case "$resolved" in
514 '')
515         case "$HAS_HEAD" in
516         '')
517                 files=$(git ls-files) ;;
518         ?*)
519                 files=$(git diff-index --cached --name-only HEAD --) ;;
520         esac || exit
521         if test "$files"
522         then
523                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
524                 die "Dirty index: cannot apply patches (dirty: $files)"
525         fi
526 esac
528 if test "$(cat "$dotest/utf8")" = t
529 then
530         utf8=-u
531 else
532         utf8=-n
533 fi
534 if test "$(cat "$dotest/keep")" = t
535 then
536         keep=-k
537 fi
538 case "$(cat "$dotest/keepcr")" in
539 t)
540         keepcr=--keep-cr ;;
541 f)
542         keepcr=--no-keep-cr ;;
543 esac
544 case "$(cat "$dotest/scissors")" in
545 t)
546         scissors=--scissors ;;
547 f)
548         scissors=--no-scissors ;;
549 esac
550 if test "$(cat "$dotest/no_inbody_headers")" = t
551 then
552         no_inbody_headers=--no-inbody-headers
553 else
554         no_inbody_headers=
555 fi
556 if test "$(cat "$dotest/quiet")" = t
557 then
558         GIT_QUIET=t
559 fi
560 if test "$(cat "$dotest/threeway")" = t
561 then
562         threeway=t
563 fi
564 git_apply_opt=$(cat "$dotest/apply-opt")
565 if test "$(cat "$dotest/sign")" = t
566 then
567         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
568                         s/>.*/>/
569                         s/^/Signed-off-by: /'
570                 `
571 else
572         SIGNOFF=
573 fi
575 last=`cat "$dotest/last"`
576 this=`cat "$dotest/next"`
577 if test "$skip" = t
578 then
579         this=`expr "$this" + 1`
580         resume=
581 fi
583 while test "$this" -le "$last"
584 do
585         msgnum=`printf "%0${prec}d" $this`
586         next=`expr "$this" + 1`
587         test -f "$dotest/$msgnum" || {
588                 resume=
589                 go_next
590                 continue
591         }
593         # If we are not resuming, parse and extract the patch information
594         # into separate files:
595         #  - info records the authorship and title
596         #  - msg is the rest of commit log message
597         #  - patch is the patch body.
598         #
599         # When we are resuming, these files are either already prepared
600         # by the user, or the user can tell us to do so by --resolved flag.
601         case "$resume" in
602         '')
603                 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
604                         <"$dotest/$msgnum" >"$dotest/info" ||
605                         stop_here $this
607                 # skip pine's internal folder data
608                 sane_grep '^Author: Mail System Internal Data$' \
609                         <"$dotest"/info >/dev/null &&
610                         go_next && continue
612                 test -s "$dotest/patch" || {
613                         echo "Patch is empty.  Was it split wrong?"
614                         echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
615                         echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
616                         stop_here $this
617                 }
618                 rm -f "$dotest/original-commit" "$dotest/author-script"
619                 if test -f "$dotest/rebasing" &&
620                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
621                                 -e q "$dotest/$msgnum") &&
622                         test "$(git cat-file -t "$commit")" = commit
623                 then
624                         git cat-file commit "$commit" |
625                         sed -e '1,/^$/d' >"$dotest/msg-clean"
626                         echo "$commit" > "$dotest/original-commit"
627                         get_author_ident_from_commit "$commit" > "$dotest/author-script"
628                 else
629                         {
630                                 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
631                                 echo
632                                 cat "$dotest/msg"
633                         } |
634                         git stripspace > "$dotest/msg-clean"
635                 fi
636                 ;;
637         esac
639         if test -f "$dotest/author-script"
640         then
641                 eval $(cat "$dotest/author-script")
642         else
643                 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
644                 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
645                 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
646         fi
648         if test -z "$GIT_AUTHOR_EMAIL"
649         then
650                 echo "Patch does not have a valid e-mail address."
651                 stop_here $this
652         fi
654         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
656         case "$resume" in
657         '')
658             if test '' != "$SIGNOFF"
659             then
660                 LAST_SIGNED_OFF_BY=`
661                     sed -ne '/^Signed-off-by: /p' \
662                     "$dotest/msg-clean" |
663                     sed -ne '$p'
664                 `
665                 ADD_SIGNOFF=`
666                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
667                     test '' = "$LAST_SIGNED_OFF_BY" && echo
668                     echo "$SIGNOFF"
669                 }`
670             else
671                 ADD_SIGNOFF=
672             fi
673             {
674                 if test -s "$dotest/msg-clean"
675                 then
676                         cat "$dotest/msg-clean"
677                 fi
678                 if test '' != "$ADD_SIGNOFF"
679                 then
680                         echo "$ADD_SIGNOFF"
681                 fi
682             } >"$dotest/final-commit"
683             ;;
684         *)
685                 case "$resolved$interactive" in
686                 tt)
687                         # This is used only for interactive view option.
688                         git diff-index -p --cached HEAD -- >"$dotest/patch"
689                         ;;
690                 esac
691         esac
693         resume=
694         if test "$interactive" = t
695         then
696             test -t 0 ||
697             die "cannot be interactive without stdin connected to a terminal."
698             action=again
699             while test "$action" = again
700             do
701                 echo "Commit Body is:"
702                 echo "--------------------------"
703                 cat "$dotest/final-commit"
704                 echo "--------------------------"
705                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
706                 read reply
707                 case "$reply" in
708                 [yY]*) action=yes ;;
709                 [aA]*) action=yes interactive= ;;
710                 [nN]*) action=skip ;;
711                 [eE]*) git_editor "$dotest/final-commit"
712                        action=again ;;
713                 [vV]*) action=again
714                        git_pager "$dotest/patch" ;;
715                 *)     action=again ;;
716                 esac
717             done
718         else
719             action=yes
720         fi
722         if test -f "$dotest/final-commit"
723         then
724                 FIRSTLINE=$(sed 1q "$dotest/final-commit")
725         else
726                 FIRSTLINE=""
727         fi
729         if test $action = skip
730         then
731                 go_next
732                 continue
733         fi
735         if test -x "$GIT_DIR"/hooks/applypatch-msg
736         then
737                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
738                 stop_here $this
739         fi
741         say "Applying: $FIRSTLINE"
743         case "$resolved" in
744         '')
745                 # When we are allowed to fall back to 3-way later, don't give
746                 # false errors during the initial attempt.
747                 squelch=
748                 if test "$threeway" = t
749                 then
750                         squelch='>/dev/null 2>&1 '
751                 fi
752                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
753                 apply_status=$?
754                 ;;
755         t)
756                 # Resolved means the user did all the hard work, and
757                 # we do not have to do any patch application.  Just
758                 # trust what the user has in the index file and the
759                 # working tree.
760                 resolved=
761                 git diff-index --quiet --cached HEAD -- && {
762                         echo "No changes - did you forget to use 'git add'?"
763                         echo "If there is nothing left to stage, chances are that something else"
764                         echo "already introduced the same changes; you might want to skip this patch."
765                         stop_here_user_resolve $this
766                 }
767                 unmerged=$(git ls-files -u)
768                 if test -n "$unmerged"
769                 then
770                         echo "You still have unmerged paths in your index"
771                         echo "did you forget to use 'git add'?"
772                         stop_here_user_resolve $this
773                 fi
774                 apply_status=0
775                 git rerere
776                 ;;
777         esac
779         if test $apply_status != 0 && test "$threeway" = t
780         then
781                 if (fall_back_3way)
782                 then
783                     # Applying the patch to an earlier tree and merging the
784                     # result may have produced the same tree as ours.
785                     git diff-index --quiet --cached HEAD -- && {
786                         say No changes -- Patch already applied.
787                         go_next
788                         continue
789                     }
790                     # clear apply_status -- we have successfully merged.
791                     apply_status=0
792                 fi
793         fi
794         if test $apply_status != 0
795         then
796                 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
797                 stop_here_user_resolve $this
798         fi
800         if test -x "$GIT_DIR"/hooks/pre-applypatch
801         then
802                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
803         fi
805         tree=$(git write-tree) &&
806         commit=$(
807                 if test -n "$ignore_date"
808                 then
809                         GIT_AUTHOR_DATE=
810                 fi
811                 parent=$(git rev-parse --verify -q HEAD) ||
812                 say >&2 "applying to an empty history"
814                 if test -n "$committer_date_is_author_date"
815                 then
816                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
817                         export GIT_COMMITTER_DATE
818                 fi &&
819                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
820         ) &&
821         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
822         stop_here $this
824         if test -f "$dotest/original-commit"; then
825                 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
826         fi
828         if test -x "$GIT_DIR"/hooks/post-applypatch
829         then
830                 "$GIT_DIR"/hooks/post-applypatch
831         fi
833         go_next
834 done
836 if test -s "$dotest"/rewritten; then
837     git notes copy --for-rewrite=rebase < "$dotest"/rewritten
838     if test -x "$GIT_DIR"/hooks/post-rewrite; then
839         "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
840     fi
841 fi
843 rm -fr "$dotest"
844 git gc --auto